*   FAULT.INS.ASM, /us/ins, jrw, 12/16/89
*   exception handler data & table definitions
*
%IFDEF us_fault_ins_asm %THEN
    %EXIT
%ELSE
    %VAR us_fault_ins_asm
%ENDIF

***************************************************************************
*                                                                         *
*  WARNING: Aegis depends on this include file; modify with trepidation.  *
*                                                                         *
***************************************************************************

* Changes
*   12/16/89 gordon added fault_$bad_bus_err_frame, fault_$cache_push_bus_err
*   09/07/89 gms    updated hopelessly out-of-date AT version.
*   11/30/88 gms    added fault_$fp_data_check.
*   06/29/88 gms    added fault_$unaligned_inst.
*   03/01/88 gms    added 43-45.
*   10/30/87 mills  added 42 (New for A88K)
*   10/29/87 joew   out of synch with /us/sys/ins/fault.ins.pas.
*   10/06/87 gms    merged at branch into mainline; added at version of fault_$diag_t.
*   10/05/87 tonyd  s/m68k/isp_$m68k/.
*   09/16/87 gms    merged mainline into /at version.
*   03/11/87 dcm    Add infor to fault frame for new signals.
*   01/28/86 sekhar Banshee fpx changes: added df_fpx_state_ptr to diagnostic frame template
*                   got rid of df_fsave_done bit.
*   11/13/86 sekhar Fpa on banshee: changed bit defn df_fpa_exception to df_fsave_done;
*                   cuz fsave done on more than just fpa exceptions; added df_m68020;
*   10/22/86 sjm  Added fault_$be_on_be for double VME bus error.
*   10/17/86 sekhar Banshee - added fault_$fp_unknown_vec for unknown fpa vector exceptions
*   08/20/86 sekhar Banshee - added fault_$fp_parity for fpa parity errors
*   08/05/86 sekhar Banshee - added bit defn df_fpa_exception in df_misc word
*                             for fpa exceptions. 
*   07/18/86 knw  added pwr_fail for banshee
*   03/15/86 gms  added fault_$cold_start_bus_error; removed fault_table_tm.
*   12/02/85 gms  added fault_$cpub_bus_error, fault_$spurious_interrupt.
*   12/28/84 gms  added codes 1C-2F.
*   07/03/82 jrw  added async flag definition for df_misc.
*   03/19/82 jrw  added codes 17-1B
*   02/22/81 pjl  added fault_$quit constant
*
*
*    --------------------------------------------------------------------------
*   |   THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.   |
*   |         AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.        |
*    --------------------------------------------------------------------------
*
*
*
fault_$address_error       equ  $00120001
fault_$illegal_inst        equ  $00120002
fault_$zero_divide         equ  $00120003
fault_$chk_inst            equ  $00120004
fault_$trapv_inst          equ  $00120005
fault_$priv_violation      equ  $00120006
fault_$illegal_svc_code    equ  $00120007
fault_$illegal_svc_name    equ  $00120008
fault_$undefined_trap      equ  $00120009
fault_$unimplemented_inst  equ  $0012000A
fault_$prot_violation      equ  $0012000B
fault_$bus_timeout         equ  $0012000C
fault_$illegal_usp         equ  $0012000D
fault_$eccc                equ  $0012000E
fault_$eccu                equ  $0012000F
fault_$quit                equ  $00120010
fault_$access_violation    equ  $00120011
fault_$not_valid           equ  $00120012
fault_$nullproc_onb        equ  $80120013
fault_$display_quit        equ  $00120014
fault_$single_step         equ  $00120015
fault_$invalid_user_fault  equ  $00120016
fault_$pbu_user_int_fault  equ  $00120017
fault_$stop                equ  $00120018
fault_$blast               equ  $00120019
fault_$cache_parity        equ  $0012001A
fault_$wcs_parity          equ  $0012001B
fault_$not_implemented     equ  $0012001C
fault_$invalid_stack       equ  $0012001D
fault_$parity              equ  $0012001E
fault_$interrupt           equ  $0012001F
fault_$while_lock_set      equ  $00120020
fault_$spurious_parity     equ  $00120021
fault_$fp_inexact          equ  $00120022
fault_$fp_div_zero         equ  $00120023
fault_$fp_undflo           equ  $00120024
fault_$fp_op_err           equ  $00120025
fault_$fp_ovrflo           equ  $00120026
fault_$suspend_proc        equ  $00120027
fault_$suspend_proc_kbd    equ  $00120028 
fault_$suspend_proc_br     equ  $00120029
fault_$suspend_proc_bw     equ  $0012002A
fault_$continue_proc       equ  $0012002B 
fault_$fault_lost          equ  $0012002C
fault_$illegal_coproc      equ  $0012002D
fault_$fp_bsun             equ  $0012002E
fault_$fp_sig_nan          equ  $0012002F
fault_$parity_bad_thread   equ  $00120030
fault_$illegal_page_fault  equ  $00120031
fault_$cpub_bus_error      equ  $00120032
fault_$spurious_interrupt  equ  $00120033
fault_$cold_start_bus_error equ $00120034
fault_$cleanup_set         equ  $00120035
fault_$cleanup_rls_out_order equ $00120036
fault_$ac_power_fail       equ  $00120037
fault_$fp_parity           equ  $00120038
fault_$fp_unknown_vec      equ  $00120039
fault_$be_on_be            equ  $0012003A
fault_$io_chan_chk         equ  $0012003b
fault_$breakpoint          equ  $0012003C 
fault_$translate_error     equ  $0012003D 
fault_$illegal_lock        equ  $0012003E 
fault_$lock_timeout        equ  $0012003F 
fault_$unknown_status      equ  $00120040 
fault_$fp_exception        equ  $00120041 
fault_$fp_fpu_internal_error equ $00120042 
fault_$pause               equ  $00120043
fault_$halt                equ  $00120044
fault_$trap_on_trap        equ  $00120045
fault_$unaligned_inst      equ  $00120046
fault_$fp_data_check       equ  $00120047
*                          equ  $00120048
fault_$bad_bus_err_frame   equ  $00120049
fault_$cache_push_bus_err  equ  $0012004A




df_pattern_val equ $DFDF

%IF ISP_$M68K %THEN

*
*   Diagnostic frame template:
*
           defs    0(a6)
df_start   equ     *
df_pattern ds.w    1                   pattern used to find diag frame
df_status  ds.l    1                   standard format status code
df_regs    equ     *                   register save area
df_d0      ds.l    1
df_d1      ds.l    1
df_d2      ds.l    1
df_d3      ds.l    1
df_d4      ds.l    1
df_d5      ds.l    1
df_d6      ds.l    1
df_d7      ds.l    1
df_a0      ds.l    1
df_a1      ds.l    1
df_a2      ds.l    1
df_a3      ds.l    1
df_a4      ds.l    1
df_a5      ds.l    1
df_a6      ds.l    1
df_a7      ds.l    1
df_fcode   ds.w    1                   function code, etc (from addr/bus err)
df_addr    ds.l    1                   access address
df_ireg    ds.w    1                   instruction register (from addr error)
df_misc    ds.w    1                   miscellaneous flags, see below
df_sup_ecb ds.l    1                   pointer to supervisor routine ecb
df_sup_sr  ds.w    1                   supervisor status register at fault time
df_sup_pc  ds.l    1                   supervisor return pc
df_sr      ds.w    1                   user status register at fault time
df_fpx_state_ptr ds.l 1                pointer to fpx state saved on user stack.
df_signo   ds.w    1                   unix signal number
df_hmask   ds.l    1                   mask of held unix signals
df_pc      ds.l    1                   user return pc (must be last)
df_end     equ     *
           ends
*
df_size    equ     df_end-df_start

%ELSE   { else isp_$a88k version }

*
*   Diagnostic frame template:
*
           defs    0
df_start   equ     *
df_prev    ds.l    1                   ; pointer to previous frame
df_pattern ds.w    1                   ; pattern used to find diag frame
df_version ds.w    1                   ; frame version
df_ret     ds.l    1                   ; space for return reg
df_link    ds.l    1                   ; pointer to previous fault frame (maintained by pfm)  
df_args    ds.l    6                   ; space for args
df_status  ds.l    1                   ; standard format status code
df_pad     ds.l    1                   ; keep FP regs aligned
df_regs    ds.l    24                  ; register save area
df_fregs   ds.l    64                  ; fp regs at fault
df_misc    ds.l    1                   ; miscellaneous flags, see below
df_hmask   ds.l    1                   ; mask of held unix signals
*                                      ; state:
df_sr      ds.l    1                   ;    user status register at fault time
df_pc      ds.l    1                   ;    user pc
df_npc     ds.l    1                   ;    user next pc
df_fp_stat ds.l    1                   ;    level 1 FPSTATUS register
df_fp_cond ds.l    1                   ;    level 1 FPCONDITION register
*                                      ; sup state:
df_sup_sr      ds.l    1               ;    status register at fault time
df_sup_pc      ds.l    1               ;    pc
df_sup_npc     ds.l    1               ;    next pc
df_sup_fp_stat ds.l    1               ;    level 1 FPSTATUS register
df_sup_fp_cond ds.l    1               ;    level 1 FPCONDITION register
df_fault_info   ds.l   1               ; ptr to info pertaining to fault
df_ip_state_ptr ds.l   1               ; ip state ptr if non-nil
df_fp_state_ptr ds.l   1               ; fp state ptr if non-nil
df_end     equ     *
           ends
*
df_size    equ     df_end-df_start

%ENDIF
*
*---"Miscellaneous" word bit definitions:
*
df_rtnp_bit equ    7                   1 if return permitted
df_in_sup_bit equ  6                   1 if fault occurred w/in supervisor
df_regs_valid equ  5                   1 if all regs valid, 0 if only a6-a7
df_ab_valid   equ  4                   1 if addr/bus info valid
df_async      equ  3                   1 if async fault
df_m68020     equ  2                   1 if 68020 processor
df_fsave_done equ  1                   1 if fsave was done. must do a frestore on return
df_onstack  equ    0                   1 if on signal stack
